;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PlantAttack: An Amstrad CPC Game.
;; 
;;
;;  This program is free software: you can redistribute it and/or
;;  modify it under the terms of the  GNU General Public License (GPLv3).
;;  
;;  If you need more information about the license GNU you can visit:
;;  https://www.gnu.org/licenses/quick-guide-gplv3.html

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Bullet Manager
;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "entity_manager.h.s"
.include "Systems/input_system.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Function Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;+++++++++++++++++++++++++++++
;; Man_Bullet_setVelocity
;;----------------------------
;;	Set the velocity of the bullet and move it to the
;; player position.
;; Input: 
;;	IX = pointer to the player entity
;; Destroys: BC, DE, IX
;;
man_bullet_setVelocity::
	ld	c,	e_x(ix)
	push	ix
	
	call man_entity_getEntityBulletIX
	ld	e_vy(ix),	#-3
	ld	 e_x(ix),	c

	pop 	ix
	ret

;;++++++++++++++++++++++++++++
;; Man_ Bullet_ResetPosition
;;---------------------------
;;	Reset the bullet position when e_y = 0, reset e_vy 
;; and moving to 0
;; Input: 
;;	IX = pointer to the bullet entity
;; Destroys: AF, IX
;;
man_bullet_resetPosition::
	ld	e_vy(ix), #0
	ld	e_y(ix), #176
	ld	a, #0
	ld	(moving), a

	ret

;;++++++++++++++++++++++++++++++++
;; Man_Bullet_Reset_Pos
;;-------------------------------
;;	Reset the bullet position when collides with an 
;; enemy.
;; Input:
;;	IY = pointer to the bullet entity
;; Destroys: AF, IY
;;
man_bullet_reset_pos::
	ld	e_vy(iy), #0
	ld	e_y(iy), #176
	ld	a, #0
	ld	(moving), a
	ret

