;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PlantAttack: An Amstrad CPC Game.
;; 
;;
;;  This program is free software: you can redistribute it and/or
;;  modify it under the terms of the  GNU General Public License (GPLv3).
;;  
;;  If you need more information about the license GNU you can visit:
;;  https://www.gnu.org/licenses/quick-guide-gplv3.html

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Entity Manager Headboard
;;--------------------------------------
;;	Includes all the globlas that you need to use entity_manager.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Function Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl man_entity_getArray
.globl man_entity_init
.globl man_entity_new
.globl man_entity_created
.globl man_entity_getEntity1HL
.globl man_entity_getEntity2HL
.globl man_entity_getEntity3HL
.globl man_entity_getEntity4HL
.globl man_entity_getEntity5HL
.globl man_entity_getEntity6HL
.globl man_entity_getEntityBullet
.globl man_entity_getEntityBulletIX
.globl man_entity_getEntityBulletIY
.globl man_entity_getArrayHL
.globl man_entity_getEntityenemyIX

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Sprites Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl _sp_plant3
.globl _sp_bullet
.globl _sp_bugui



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Define Macro Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.macro DefineCmp_Entity_Default
	DefineCmp_Entity 0, 0, 0, 0, 1, 1, 0x0000, e_ai_st_noAI, 0, 0
.endm


;; Definition of entity macro
.macro DefineCmp_Entity  _x, _y, _vx, _vy, _w, _h, _pspr, _aist, _pat, _type
  	.db _x, _y 	;; positiion
  	.db _vx, _vy;; velocity
  	.db _w, _h 	;; size
  	.dw _pspr 	;; sprite pointer
  	.db 0x00, 0x00	;; AI aim  x, Ai aim pos y
  	.db _aist	;; Ai status
  	.db _aist	;; Ai previous status (ai_pre_st)
    .dw 0x0000  ;;next ai patrol step
    .db _pat       ;; patrol
    .db _type   ;; entity type (player,bullet, etc)
  	.dw 0xcccc	;; last video memory pointer value
  	
  		
.endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Entity t offsets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
e_x        = 0
e_y        = 1
e_vx       = 2
e_vy       = 3
e_w        = 4
e_h        = 5
e_pspr     = 6
e_pspr_l   = 6
e_pspr_h   = 7 
e_ai_aim_x = 8
e_ai_aim_y = 9
e_ai_st    = 10
e_ai_pre_st= 11
e_ai_patrol_step_l = 12
e_ai_patrol_step_h = 13
e_pat      = 14
e_type     = 15
e_lastVP_l = 16
e_lastVP_h = 17
sizeof_e   = 18

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Entity AI Status Enum
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
e_ai_st_noAI= 0
e_ai_st_AI_appear	= 1
e_ai_st_AI_move	= 2
e_ai_st_AI_patrol	= 3
e_ai_st_AI_bullet = 4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Constant Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
e_w_invalidEntity = -1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Types
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;1 - player
;0 - enemy
;2 - player_bullet
;3 - enemy_bullet
