;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PlantAttack: An Amstrad CPC Game.
;; 
;;
;;  This program is free software: you can redistribute it and/or
;;  modify it under the terms of the  GNU General Public License (GPLv3).
;;  
;;  If you need more information about the license GNU you can visit:
;;  https://www.gnu.org/licenses/quick-guide-gplv3.html

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Patrol Manager
;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "patrol_manager.h.s"
.include "Managers/entity_manager.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Define Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
patrol_1:
	.db 60, 120
	.db 40, 119
	.db 10, 123
	.db patrol_invalid_move_x
	.dw patrol_1

patrol_2:
	.db 30, 10
	.db 55, 9
	.db 10, 13
	.db 17, 17
	.db patrol_invalid_move_x
	.dw patrol_2

patrol_3:
	.db 20, 50
	.db 60, 60
	.db 54, 53
	.db 27, 57
	.db patrol_invalid_move_x
	.dw patrol_3

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Function Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;++++++++++++++++++++++++++++++
;; Man_Patrol_Init
;;-----------------------------
;;	Init the patrol manager.
;; Input: 
;;	IX = pointer tot he entity_array
;; Destroys: AF, DE, HL, IX
;;
man_patrol_init::
	;; first patrol will be patrol id 0

_loop:
	;; esxit on invalid entity
	ld	a, e_w(ix)
	cp	#e_w_invalidEntity 
	ret	z

	;; Check if it has AI
	ld 	a, e_ai_st(ix)
	cp	#e_ai_st_noAI
	jr	z, _no_ai_ent

	;; entity has AI, set patrol
	 
	ld	a, e_pat(ix)
	call	man_patrol_get
	ld	e_ai_patrol_step_l(ix), l
	ld	e_ai_patrol_step_h(ix), h
	;inc 	b

_no_ai_ent:
	;;jump to next entity
	ld	de, #sizeof_e
	add	ix, de
	

	jr	_loop

;;+++++++++++++++++++++++++++++++++
;; Man_Patrol_Get
;;----------------------------
;;	Return the patrol.
;; Input: -
;; Destroys: AF, HL
;; Return:
;;	HL = pointer to patrol
;;
man_patrol_get::
	or 	a
	cp 	#0
	jr	z, _p1

	cp 	#1
	jr	z, _p2

	cp 	#2
	jr	z, _p3


_p1:	
	ld 	hl, #patrol_1
	ret

_p2:
	ld	hl, #patrol_2
	ret

_p3:
	ld	hl, #patrol_3
	
	ret