;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PlantAttack: An Amstrad CPC Game.
;; 
;;
;;  This program is free software: you can redistribute it and/or
;;  modify it under the terms of the  GNU General Public License (GPLv3).
;;  
;;  If you need more information about the license GNU you can visit:
;;  https://www.gnu.org/licenses/quick-guide-gplv3.html

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  Colision System
;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "cpctelera.h.s"
.include "Managers/entity_manager.h.s"
.include "Managers/game_manager.h.s"
.include "Controllers/menu_controller.h.s"
.include "Managers/bullet_manager.h.s"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Define Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
death: .db #0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Function Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;+++++++++++++++++++++++++++++++++++++++++
;; Sys_Colision_controller
;;----------------------------------------
;;  Check if the entity colisionable is the 
;; player or an enemy, then pass in Iy the
;; bullet.
;; Input:
;;    IX = pointer tot he entity array
;; Destroys: AF, BC, DE, IX
;;
sys_colision_controller::
  ;;ld (_ent_array_ptr), ix

  ld a, e_type(ix)
  cp #0
  jp z, _no_player

  call man_entity_getEntityBulletIY
 
  ;ld iy, #data_bullet

  call sys_colision_check


  ret

_no_player:
 call man_entity_getEntityBulletIY
 

  call sys_colision_check

  ret

;;+++++++++++++++++++++++++++++++++++
;; Sys_Colision_Check
;;-----------------------------------
;;    Compare the collide between the 
;; entity and the enemies
;; Input: 
;;    IX = pointer tot he first enemy
;;    IY = pointer to the bullet entity
;; Destroys: AF, BC, DE, IX, IY
;; 
sys_colision_check::
  call man_entity_getArray
  ld  (_ent_counter), a

  call man_entity_getEntityBulletIX
  ld de, #sizeof_e
  add ix, de

_update_loop:

	ld a,e_x(ix)
	add e_w(ix)
  ld b, e_x(iy)
	sub e_x(iy)
  jr c, _no_colision


	ld a,e_x(iy)
  add e_w(iy)
	sub e_x(ix)
  jr c, _no_colision


	ld a,e_y(ix)
	add e_h(ix)
	sub e_y(iy)
  jr c, _no_colision


	ld a,e_y(iy)
	add e_h(iy)
	sub e_y(ix)
	jr c, _no_colision


  ld a, #0
  ld e_x(ix), a

  call man_bullet_reset_pos

  ld a, (death)
  inc a
  cp #20
  jp z, _end
  ld (death), a


  call sys_colision_distroyer_entity
 _ent_counter = .+1
  ld  a, #0
  dec   a
  ret   z

  ld  (_ent_counter), a
  ld  bc, #sizeof_e
  add   ix, bc
  jr _update_loop

_end:
  ld a, #0
  ld (death), a
  call m_menu_init


_no_colision:

  _ent_counter = .+1
  ld  a, #0
  dec   a
  ret   z

  ld  (_ent_counter), a
  ld  bc, #sizeof_e
  add   ix, bc
  jr _update_loop

;;+++++++++++++++++++++++++++++
;; Sys_Colision_Distroyer_Entity
;;------------------------------
;;    Check if the enemy is a player or an enemy.
;; If it is a player less one life, unless move 
;; destroy the enemy.
;; Input: 
;;    IX = pointer to the collide entity
;; Destroys: AF, IX
sys_colision_distroyer_entity::

  ld a, e_type(ix)
  cp #1
  jp z, check_life

  

  call sys_colision_kill_enemy

  ret

;;mata al enemigo
;;++++++++++++++++++++++++++++++++++
;; Sys_Colision_Kill_Enemy
;;-------------------------------
;;   Kill the enemy.
;; Inpout: -
;; Destroys: -
;;
sys_colision_kill_enemy::

  ret 
;; Life of the player
controlador: .db 3

;; check if the player has life

check_life:

  ld a, (controlador)
  cp #0
  jp z, man_game_init

  ld a, (controlador)
  sub #1
  ld (controlador), a



  ret

