;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PlantAttack: An Amstrad CPC Game.
;; 
;;
;;  This program is free software: you can redistribute it and/or
;;  modify it under the terms of the  GNU General Public License (GPLv3).
;;  
;;  If you need more information about the license GNU you can visit:
;;  https://www.gnu.org/licenses/quick-guide-gplv3.html

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	Input System
;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "Managers/entity_manager.h.s"
.include "cpctelera_functions.h.s"
.include "cpctelera.h.s"
.include "Managers/bullet_manager.h.s"
.include "input_system.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Define Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
moving: .db 0 ;; Acts as a boolean

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Function Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;++++++++++++++++++++++++++++++++
;; Sys_Input_Init
;;-------------------------------
;;	Initializes input system.
;; Input: -
;; Destroys: -
;;
sys_input_init::
	ret

;;+++++++++++++++++++++++++++++++++
;; Sys_Input_Update
;;--------------------------------
;;	Gets keyboard inputs and applies
;; them to keyboard controlled entities.
;;	At present moment, only entity[0]
;; is considered to be keyboard controlled.
;;	Assumes entity 0 always exists
;; Input:
;;	IX = pointer to entity[0]
;; Destroys: AF, BC, DE, HL, iX
;;
sys_input_update::
	;;reset velocity
	ld 	e_vx(ix), #0

	;;scan the keyboard
	call cpct_scanKeyboard_f_asm

	;;check fot movement keys
	ld	 hl, #Key_O
	call cpct_isKeyPressed_asm
	jr 	z, O_NotPressed

O_Pressed:
	ld 	e_vx(ix), #-1	;; go to the left side

O_NotPressed:
	ld 	hl, #Key_P
	call cpct_isKeyPressed_asm
	jr 	z, P_NotPressed

P_Pressed:
	ld 	e_vx(ix), #1	;; go to the right side

P_NotPressed:
	ld 	hl,	#Key_Space
	call	cpct_isKeyPressed_asm
	jr 	z,	space_notPressed

space_Pressed:
	;; Check if moving = 0. If moving = 1 means that velocity is set
	ld 	a,	(moving)
	cp	#0
	jp	z, 	man_bullet_setVelocity
	;; Change the value of moving to 1
	ld	a,		#1
	ld 	(moving),	a

space_notPressed:
	
	
	ret
