;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of PlantAttack: An Amstrad CPC Game.
;; 
;;
;;  This program is free software: you can redistribute it and/or
;;  modify it under the terms of the  GNU General Public License (GPLv3).
;;  
;;  If you need more information about the license GNU you can visit:
;;  https://www.gnu.org/licenses/quick-guide-gplv3.html


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include Section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "cpctelera_functions.h.s"
.include "Managers/game_manager.h.s"
.include "Managers/entity_manager.h.s"
.include "Controllers/menu_controller.h.s"
.include "Systems/colision_system.h.s"

;;
;; Start of _DATA area 
;;  SDCC requires at least _DATA and _CODE areas to be declared, but you may use
;;  any one of them for any purpose. Usually, compiler puts _DATA area contents
;;  right after _CODE area contents.
;;
.area _DATA

;;
;; Start of _CODE area
;; 
.area _CODE

;; 
;; Declare all function entry points as global symbols for the compiler.
;; (The linker will know what to do with them)
;; WARNING: Every global symbol declared will be linked, so DO NOT declare 
;; symbols for functions you do not use.
;;
.globl cpct_disableFirmware_asm
.globl cpct_getScreenPtr_asm
.globl cpct_setDrawCharM1_asm
.globl cpct_drawStringM1_asm

;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm

   ;; Initialize the game
   call man_game_init

   ;; Draw the menu
   call m_menu_init

   ;; Loop forever
loop:

	;; Start the game
	call m_controller_play

   ;;update all the systems
   call man_game_update

	;;waitNSyncs 2
	call cpct_waitVSYNC_asm
   call m_controller_boolean_value
   cp    #0
   jr    z,loop
   
   call man_game_render

   jr    loop
